#ifndef __RAND_H__
#define __RAND_H__ 

#include <stdlib.h>

double gaussian_propose_pos(double last, double *l_q_fwd, double *l_q_bak, double var);
double unif_propose_pos(double last, double *lqfwd, double *lqbak, double prop);
double unif_propose_bound(double x, double min, double max, double win, double *lqfwd, double *lqbak);
double unif_propose_prop(double x, double win, double *lqfwd, double *lqbak);
double unif_propose(double x, double win, double *lqfwd, double *lqbak);
int    sample_uniform(int max);
void   perm(int *out, int n);
double sample_trunc_gaussian(double mean, double var, double l, double u);
double sample_trunc_gaussian_l(double mean, double var, double l);
double truncgaussian_propose_bound(double x, double min, double max, double win, double *lqfwd, double *lqbak);
unsigned int sample_discrete(double prob[], unsigned int n);

#endif
